"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NULL_SYMBOL = exports.REJECTED = exports.FULFILLED = void 0;
/**
 * Constant `FULFILLED` is used in place of the string `'fulfilled'` to
 * ensure the type system will properly infer the "flag nature" of this
 * string rather than the more generic `string` type.
 * @public
 */
exports.FULFILLED = 'fulfilled';
/**
 * Constant `REJECTED` is used in place of the string `'rejected'` to
 * ensure the type system will properly infer the "flag nature" of this
 * string rather than the more generic `string` type.
 * @public
 */
exports.REJECTED = 'rejected';
/**
 * Constant `NULL_SYMBOL` is a unique symbol that represents `null` or a union type that includes `null`.
 * @public
 */
exports.NULL_SYMBOL = Symbol.for('NULL_SYMBOL');
//# sourceMappingURL=constants.js.map