"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.awaitedMapping = void 0;
var tslib_1 = require("tslib");
var assertions_1 = require("../helpers/assertions");
var core_1 = require("./core");
/**
 * @beta
 */
function awaitedMapping(collection, transformFn, lookupFn, validateFn, errLookupFn) {
    var _this = this;
    if (transformFn === void 0) { transformFn = function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); }; }
    if (lookupFn === void 0) { lookupFn = function (v) { return void v; }; }
    if (validateFn === void 0) { validateFn = function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void v];
    }); }); }; }
    if (errLookupFn === void 0) { errLookupFn = function (v) { return void v; }; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var values, _a, _b, result;
        var _this = this;
        return tslib_1.__generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = [[]];
                    if (!(0, assertions_1.isPromiseLike)(collection)) return [3 /*break*/, 2];
                    return [4 /*yield*/, collection];
                case 1:
                    _b = _c.sent();
                    return [3 /*break*/, 3];
                case 2:
                    _b = collection;
                    _c.label = 3;
                case 3:
                    values = tslib_1.__spreadArray.apply(void 0, _a.concat([tslib_1.__read.apply(void 0, [(_b)]), false]));
                    result = values.map(function (item, index, array) {
                        return (0, core_1.fn_a1f9a)({
                            item: item,
                            index: index,
                            array: array,
                            transform: transformFn == null ? function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2 /*return*/, value];
                            }); }); } : transformFn,
                            lookup: lookupFn == null ? function (v) { return void v; } : lookupFn,
                            validate: validateFn == null ? function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2 /*return*/, void v];
                            }); }); } : validateFn,
                            errLookup: errLookupFn == null ? function (v) { return void v; } : errLookupFn,
                        });
                    });
                    return [2 /*return*/, Promise.all(result)];
            }
        });
    });
}
exports.awaitedMapping = awaitedMapping;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=awaitedMapping.js.map