"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeSettler = void 0;
var tslib_1 = require("tslib");
var assertions_1 = require("../../helpers/assertions");
var tools_1 = require("../../helpers/tools");
var makeFulfillement_1 = require("./makeFulfillement");
var makeRejection_1 = require("./makeRejection");
// export function makeSettler<T>(
//   item:
//     | T
//     | PromiseLike<T>
//     | Settled<T>
//     | PromiseLike<Settled<T>>
//     | PromiseSettledResult<T>
//     | PromiseLike<PromiseSettledResult<T>>
//     | SettledRight<T>
//     | PromiseLike<SettledRight<T>>
//     | PromiseFulfilledResult<T>
//     | PromiseLike<PromiseFulfilledResult<T>>
//     | SettledLeft
//     | PromiseLike<SettledLeft>
//     | PromiseRejectedResult
//     | PromiseLike<PromiseRejectedResult>,
//   index?: number
// ):
//   | Settled<T>
//   | Promise<Settled<T>>
//   | SettledRight<T>
//   | Promise<SettledRight<T>>
//   | SettledLeft
//   | Promise<SettledLeft>;
// FUNC DEF:(makeSettler<T>) --------------------------------------------
function makeSettler(item, index) {
    var _this = this;
    if (index === void 0) { index = -1; }
    return (0, assertions_1.isPromiseLike)(item)
        ? (function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { var _a; return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = makeSettler_;
                    return [4 /*yield*/, item];
                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent(), index])];
            }
        }); }); })()
        : makeSettler_(item, index);
}
exports.makeSettler = makeSettler;
// FUNC DEF:(makeSettler_<T>) ----------------------------------------
/** @internal */
function makeSettler_(item, index) {
    var itemTransformStep = (0, tools_1.getTransformStep)(item, 0);
    var transformStep = -1;
    if (!(0, assertions_1.isPromiseSettledResult)(item) || (0, assertions_1.isPromiseFulfilledResult)(item)) {
        var itemValue = void 0;
        var base_1;
        if ((0, assertions_1.isSettledRight)(item) || (0, assertions_1.isPromiseFulfilledResult)(item)) {
            transformStep = itemTransformStep;
            itemValue = item.value;
            base_1 = item;
        }
        else {
            transformStep = 0;
            itemValue = item;
            base_1 = { value: itemValue, status: 'fulfilled' };
        }
        return (0, makeFulfillement_1.makeFulfillement)({
            value: itemValue,
            index: index,
            transformStep: transformStep,
            base: base_1,
        });
    }
    var base = item;
    var reason = item.reason;
    transformStep = (0, tools_1.getTransformStep)(item, 0);
    return (0, makeRejection_1.makeRejection)({
        reason: reason,
        index: index,
        transformStep: transformStep,
        currentRejection: false,
        base: base,
    });
}
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=makeSettler.js.map