"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serialMapping = void 0;
var tslib_1 = require("tslib");
var assertions_1 = require("../helpers/assertions");
var core_1 = require("./core");
/**
 * @beta
 */
function serialMapping(collection, transformFn, lookupFn, validateFn, errLookupFn) {
    var _this = this;
    if (transformFn === void 0) { transformFn = function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, value];
    }); }); }; }
    if (lookupFn === void 0) { lookupFn = function (v) { return void v; }; }
    if (validateFn === void 0) { validateFn = function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
        return [2 /*return*/, void v];
    }); }); }; }
    if (errLookupFn === void 0) { errLookupFn = function (v) { return void v; }; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var array, _a, index, results, array_1, array_1_1, item, _b, _c, e_1_1;
        var e_1, _d;
        var _this = this;
        return tslib_1.__generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!(0, assertions_1.isPromiseLike)(collection)) return [3 /*break*/, 2];
                    _a = [[]];
                    return [4 /*yield*/, collection];
                case 1:
                    array = tslib_1.__spreadArray.apply(void 0, _a.concat([tslib_1.__read.apply(void 0, [(_e.sent())]), false]));
                    return [3 /*break*/, 3];
                case 2:
                    array = tslib_1.__spreadArray([], tslib_1.__read(collection), false);
                    _e.label = 3;
                case 3:
                    index = 0;
                    results = [];
                    _e.label = 4;
                case 4:
                    _e.trys.push([4, 9, 10, 11]);
                    array_1 = tslib_1.__values(array), array_1_1 = array_1.next();
                    _e.label = 5;
                case 5:
                    if (!!array_1_1.done) return [3 /*break*/, 8];
                    item = array_1_1.value;
                    _c = (_b = results).push;
                    return [4 /*yield*/, (0, core_1.fn_a1f9a)({
                            item: item,
                            index: index++,
                            array: array,
                            transform: transformFn == null ? function (value) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2 /*return*/, value];
                            }); }); } : transformFn,
                            lookup: lookupFn == null ? function (v) { return void v; } : lookupFn,
                            validate: validateFn == null ? function (v) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                                return [2 /*return*/, void v];
                            }); }); } : validateFn,
                            errLookup: errLookupFn == null ? function (v) { return void v; } : errLookupFn,
                        })];
                case 6:
                    _c.apply(_b, [_e.sent()]);
                    _e.label = 7;
                case 7:
                    array_1_1 = array_1.next();
                    return [3 /*break*/, 5];
                case 8: return [3 /*break*/, 11];
                case 9:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 11];
                case 10:
                    try {
                        if (array_1_1 && !array_1_1.done && (_d = array_1.return)) _d.call(array_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 11: return [2 /*return*/, results];
            }
        });
    });
}
exports.serialMapping = serialMapping;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=serialMapping.js.map