"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPromiseRejectedResult = exports.isPromiseFulfilledResult = exports.isPromiseSettledResult = void 0;
var constants_1 = require("../../constants");
/** @public */
function isPromiseSettledResult(contender) {
    return (isPromiseFulfilledResult(contender) || isPromiseRejectedResult(contender));
}
exports.isPromiseSettledResult = isPromiseSettledResult;
/** @public */
function isPromiseFulfilledResult(contender) {
    var result = false;
    try {
        result =
            contender != null &&
                typeof contender === 'object' &&
                'status' in contender &&
                contender.status === constants_1.FULFILLED &&
                'value' in contender;
    }
    catch (_a) {
        // Do nothing
        /*
            The addition of the try/catch block
            ensure that the function does not throw any exceptions
            if an unexpected error occurs.
          */
    }
    return result;
}
exports.isPromiseFulfilledResult = isPromiseFulfilledResult;
/** @public */
function isPromiseRejectedResult(contender) {
    var result = false;
    try {
        result =
            contender != null &&
                typeof contender === 'object' &&
                'status' in contender &&
                contender.status === constants_1.REJECTED &&
                'reason' in contender;
    }
    catch (_a) {
        // Do nothing
        /*
            The addition of the try/catch block
            ensure that the function does not throw any exceptions
            if an unexpected error occurs.
          */
    }
    return result;
}
exports.isPromiseRejectedResult = isPromiseRejectedResult;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=isPromiseSettledResult.js.map