"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSettledLeft = exports.isSettledRight = exports.hasTransformStep = exports.isSettled = void 0;
var constants_1 = require("../../constants");
/** @public */
function isSettled(contender) {
    return isSettledRight(contender) || isSettledLeft(contender);
}
exports.isSettled = isSettled;
/** @public*/
function hasTransformStep(countender) {
    var result = false;
    try {
        result =
            countender != null &&
                typeof countender === 'object' &&
                'transformStep' in countender &&
                typeof countender.transformStep === 'number';
    }
    catch (_a) {
        // Do nothing
        /*
          The addition of the try/catch block
          ensure that the function does not throw any exceptions
          if an unexpected error occurs.
        */
    }
    return result;
}
exports.hasTransformStep = hasTransformStep;
/** @public */
function isSettledRight(contender) {
    var result = false;
    try {
        if (typeof contender === 'object' && contender !== null) {
            result =
                'status' in contender &&
                    'value' in contender &&
                    'currentRejection' in contender &&
                    'transformStep' in contender &&
                    typeof contender.transformStep === 'number' &&
                    'index' in contender &&
                    typeof contender.index === 'number' &&
                    (('reason' in contender && contender.reason === undefined) ||
                        !('reason' in contender)) &&
                    //
                    constants_1.FULFILLED in contender &&
                    constants_1.REJECTED in contender &&
                    contender.rejected === null &&
                    //
                    contender.status === constants_1.FULFILLED &&
                    contender.value === contender[constants_1.FULFILLED] &&
                    //
                    contender.currentRejection === null;
        }
    }
    catch (_a) {
        // Do nothing
        /*
          The addition of the try/catch block
          ensure that the function does not throw any exceptions
          if an unexpected error occurs.
        */
    }
    return result;
}
exports.isSettledRight = isSettledRight;
/** @public */
function isSettledLeft(contender) {
    var result = false;
    try {
        result =
            typeof contender === 'object' &&
                contender !== null &&
                //
                'status' in contender &&
                'reason' in contender &&
                'currentRejection' in contender &&
                'transformStep' in contender &&
                typeof contender.transformStep === 'number' &&
                'index' in contender &&
                typeof contender.index === 'number' &&
                (('value' in contender && contender.value === undefined) ||
                    !('value' in contender)) &&
                //
                constants_1.REJECTED in contender &&
                constants_1.FULFILLED in contender &&
                contender.fulfilled === null &&
                //
                contender.status === constants_1.REJECTED &&
                contender.reason === contender[constants_1.REJECTED] &&
                //
                (contender.currentRejection === true ||
                    contender.currentRejection === false ||
                    contender.currentRejection === undefined);
    }
    catch (_a) {
        // Do nothing
        /*
          The addition of the try/catch block
          ensure that the function does not throw any exceptions
          if an unexpected error occurs.
        */
    }
    return result;
}
exports.isSettledLeft = isSettledLeft;
// TASK LIST: [TODO] (Review Documentation) --------------------------
//# sourceMappingURL=isSettled.js.map