"use strict";
/**
 * A library for mapping tools.
 *
 *
 * The `@luxcium/mapping-tools` library defines 5 core functions used to map on iterables with diferent outcomes in mind
 * - {@link awaitedMapping}
 * - {@link generateMappingAsync}
 * - {@link generateMapping}
 * - {@link parallelMapping}
 * - {@link serialMapping}
 *
 * @remarks
 * Each function takes a collection as its first argument which can
 * be any iterable and can take on of 4 optional life cycle hooks:
 * - {@link TransformFn}
 * - {@link LookupFn}
 * - {@link ValidateFn}
 * - {@link ErrLookupFn}
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Iteration_protocols#the_iterable_protocol | The Iterable Protocol}
 * @packageDocumentation
 */
/**
 * This is the doc comment for file1.ts
 *
 * Specify this is a module comment and rename it to my-module:
 * @module my-module
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.tools = exports.NULL_SYMBOL = exports.REJECTED = exports.FULFILLED = exports.assertionTools = exports.functions = exports.constants = exports.serialMapping = exports.parallelMapping = exports.generateMappingAsync = exports.generateMapping = exports.awaitedMapping = exports.Chain = void 0;
var tslib_1 = require("tslib");
var constants = tslib_1.__importStar(require("./constants"));
exports.constants = constants;
var functions = tslib_1.__importStar(require("./functions"));
exports.functions = functions;
// import * as helpers from './helpers';
var assertionTools = tslib_1.__importStar(require("./helpers/assertions"));
exports.assertionTools = assertionTools;
// import * as tools from './helpers/tools';
var chain_1 = require("./classes/chain");
Object.defineProperty(exports, "Chain", { enumerable: true, get: function () { return chain_1.Chain; } });
var awaitedMapping_1 = require("./functions/awaitedMapping");
Object.defineProperty(exports, "awaitedMapping", { enumerable: true, get: function () { return awaitedMapping_1.awaitedMapping; } });
var generateMapping_1 = require("./functions/generateMapping");
Object.defineProperty(exports, "generateMapping", { enumerable: true, get: function () { return generateMapping_1.generateMapping; } });
var generateMappingAsync_1 = require("./functions/generateMappingAsync");
Object.defineProperty(exports, "generateMappingAsync", { enumerable: true, get: function () { return generateMappingAsync_1.generateMappingAsync; } });
var parallelMapping_1 = require("./functions/parallelMapping");
Object.defineProperty(exports, "parallelMapping", { enumerable: true, get: function () { return parallelMapping_1.parallelMapping; } });
var serialMapping_1 = require("./functions/serialMapping");
Object.defineProperty(exports, "serialMapping", { enumerable: true, get: function () { return serialMapping_1.serialMapping; } });
/** @public */
var tools_1 = require("./helpers/tools");
/** @public */
exports.FULFILLED = constants.FULFILLED;
/** @public */
exports.REJECTED = constants.REJECTED;
/** @public */
exports.NULL_SYMBOL = constants.NULL_SYMBOL;
// @alpha, @beta, /** @public */, or @internal
// export const assertions: typeof helpers.assertions = helpers.assertions;
// /** @public */
// export const tools: typeof helpers.tools = helpers.tools;
// export const { assertions, tools } = helpers;
/** @public */
exports.tools = {
    extractFulfilledValues: tools_1.extractFulfilledValues,
    extractSettledValues: tools_1.extractSettledValues,
    filterLeft: tools_1.filterLeft,
    filterRight: tools_1.filterRight,
    getTransformStep: tools_1.getTransformStep,
};
// /** @public */
// export const assertions = {
//   isPromise,
//   isPromiseLike,
//   isPromiseFulfilledResult,
//   isPromiseRejectedResult,
//   isPromiseSettledResult,
//   hasTransformStep,
//   isSettled,
//   isSettledLeft,
//   isSettledRight,
// };
// import * as helpers2 from './helpers';
// export default {
//   helpers,
//   constants,
//   functions,
//   ...helpers,
//   ...assertions,
//   ...tools,
//   ...constants,
//   ...functions,
// };
//# sourceMappingURL=index.js.map