import { BaseOrDeferred, Collection, ErrLookupFn, LookupFn, Settled, SettledLeft, SettledRight, TransformFn, ValidateFn } from '../types';
/**
 * UNSAFE: Name of the class will change in future release
 * @alpha
 */
export declare class Chain<B> {
    private collection;
    private _list;
    get list(): Promise<BaseOrDeferred<B>[]>;
    static of<BType>(collection: Collection<BType> | PromiseLike<Collection<BType>>): Chain<BType>;
    private constructor();
    generateMapping<R>(transformFn?: TransformFn<B, R> | null, lookupFn?: LookupFn<B, R> | null, validateFn?: ValidateFn<B, R> | null, errLookupFn?: ErrLookupFn | null): Chain<Promise<Settled<R>>>;
    generateMappingAsync<R>(transformFn?: TransformFn<B, R> | null, lookupFn?: LookupFn<B, R> | null, validateFn?: ValidateFn<B, R> | null, errLookupFn?: ErrLookupFn | null): Chain<R>;
    serialMapping<R>(transformFn?: TransformFn<B, R> | null, lookupFn?: LookupFn<B, R> | null, validateFn?: ValidateFn<B, R> | null, errLookupFn?: ErrLookupFn | null): Chain<R>;
    awaitedMapping<R>(transformFn?: TransformFn<B, R> | null, lookupFn?: LookupFn<B, R> | null, validateFn?: ValidateFn<B, R> | null, errLookupFn?: ErrLookupFn | null): Chain<R>;
    parallelMapping<R>(transformFn?: TransformFn<B, R> | null, lookupFn?: LookupFn<B, R> | null, validateFn?: ValidateFn<B, R> | null, errLookupFn?: ErrLookupFn | null): Chain<Promise<Settled<R>>>;
    filterRight(): Promise<SettledRight<B>[]>;
    filterLeft(): Promise<SettledLeft[]>;
    extractFulfilledValues(): Promise<B[]>;
    extractSettledValues(): Promise<(typeof import("../constants").NULL_SYMBOL | B)[]>;
}
//# sourceMappingURL=chain.d.ts.map