import { Settled, SettledLeft, SettledRight } from '../../types';
/** @internal */
/**
 * **Promise\<Combo\>**: SettledLeft **or** SettledRight<T> as Settled<T>
 * @param item T | Settled<T> | PromiseSettledResult<T>
 * @param index number
 */
export declare function makeSettler<T>(item: PromiseLike<T | Settled<T> | PromiseSettledResult<T>>, index?: number): Promise<Settled<T>>;
/**
 * **Promise\<Right\>**: T will be resolved right (SettledRight<T>)
 * @param item T | SettledRight<T> | PromiseFulfilledResult<T>
 * @param index number
 */
export declare function makeSettler<T>(item: PromiseLike<T | SettledRight<T> | PromiseFulfilledResult<T>>, index?: number): Promise<SettledRight<T>>;
/**
 * **Promise\<Left\>**: SettledLeft
 * @param item SettledLeft | PromiseRejectedResult
 * @param index number
 */
export declare function makeSettler<T>(item: PromiseLike<SettledLeft | PromiseRejectedResult>, index?: number): Promise<SettledLeft>;
/**
 * **Promise\<TBase\>**: T will be resolved right (SettledRight<T>)
 * @param item T
 * @param index number
 */
export declare function makeSettler<T>(item: PromiseLike<T>, index?: number): Promise<SettledRight<T>>;
/**
 * **Combo**: SettledLeft **or** SettledRight<T> as Settled<T>
 * @param item T | Settled<T> | PromiseSettledResult<T>
 * @param index number
 */
export declare function makeSettler<T>(item: T | Settled<T> | PromiseSettledResult<T>, index?: number): Settled<T>;
/**
 * **Right**: T will be resolved right (SettledRight<T>)
 * @param item T | SettledRight<T> | PromiseFulfilledResult<T>
 * @param index number
 */
export declare function makeSettler<T>(item: T | SettledRight<T> | PromiseFulfilledResult<T>, index?: number): SettledRight<T>;
/**
 * **Left**: SettledLeft
 * @param item SettledLeft | PromiseRejectedResult
 * @param index number
 */
export declare function makeSettler<T>(item: SettledLeft | PromiseRejectedResult, index?: number): SettledLeft;
/**
 * **TBase**: T will be resolved right (SettledRight<T>)
 * @param item T
 * @param index number
 */
export declare function makeSettler<T>(item: T, index?: number): SettledRight<T>;
export declare function makeSettler<T>(item: T | PromiseLike<T> | PromiseFulfilledResult<T> | PromiseLike<PromiseFulfilledResult<T>>, index?: number): SettledRight<T> | Promise<SettledRight<T>>;
export declare function makeSettler<T>(item: PromiseRejectedResult | PromiseLike<PromiseRejectedResult>, index?: number): SettledLeft | Promise<SettledLeft>;
export declare function makeSettler<T>(item: T | PromiseLike<T> | PromiseSettledResult<T> | PromiseLike<PromiseSettledResult<T>>, index?: number): Settled<T> | Promise<Settled<T>>;
//# sourceMappingURL=makeSettler.d.ts.map